Index: /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/Olympus.pm
===================================================================
--- /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/Olympus.pm	(revision 34920)
+++ /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/Olympus.pm	(revision 34921)
@@ -2895,25 +3333,9 @@
         Format => 'rational32u',
     },
-    0x611 => {
-        Name => 'ValidPixelDepth',
-        Writable => 'int16u',
-        Count => 2,
-    },
-    0x612 => { #11
-        Name => 'CropLeft',
-        Writable => 'int16u',
-    },
-    0x613 => { #11
-        Name => 'CropTop',
-        Writable => 'int16u',
-    },
-    0x614 => {
-        Name => 'CropWidth',
-        Writable => 'int32u',
-    },
-    0x615 => {
-        Name => 'CropHeight',
-        Writable => 'int32u',
-    },
+    0x611 => { Name => 'ValidPixelDepth',   Writable => 'int16u', Count => 2 },
+    0x612 => { Name => 'CropLeft',          Writable => 'int16u' }, #11
+    0x613 => { Name => 'CropTop',           Writable => 'int16u' }, #11
+    0x614 => { Name => 'CropWidth',         Writable => 'int32u' },
+    0x615 => { Name => 'CropHeight',        Writable => 'int32u' },
     0x1000 => {
         Name => 'LightSource',
@@ -2935,67 +3357,18 @@
     },
     # the following 5 tags all have 3 values: val, min, max
-    0x1001 => {
-        Name => 'WhiteBalanceComp',
-        Writable => 'int16s',
-        Count => 3,
-    },
-    0x1010 => {
-        Name => 'SaturationSetting',
-        Writable => 'int16s',
-        Count => 3,
-    },
-    0x1011 => {
-        Name => 'HueSetting',
-        Writable => 'int16s',
-        Count => 3,
-    },
-    0x1012 => {
-        Name => 'ContrastSetting',
-        Writable => 'int16s',
-        Count => 3,
-    },
-    0x1013 => {
-        Name => 'SharpnessSetting',
-        Writable => 'int16s',
-        Count => 3,
-    },
+    0x1001 => { Name => 'WhiteBalanceComp',         Writable => 'int16s', Count => 3 },
+    0x1010 => { Name => 'SaturationSetting',        Writable => 'int16s', Count => 3 },
+    0x1011 => { Name => 'HueSetting',               Writable => 'int16s', Count => 3 },
+    0x1012 => { Name => 'ContrastSetting',          Writable => 'int16s', Count => 3 },
+    0x1013 => { Name => 'SharpnessSetting',         Writable => 'int16s', Count => 3 },
     # settings written by Camedia Master 4.x
-    0x2000 => {
-        Name => 'CMExposureCompensation',
-        Writable => 'rational64s',
-    },
-    0x2001 => {
-        Name => 'CMWhiteBalance',
-        Writable => 'int16u',
-    },
-    0x2002 => {
-        Name => 'CMWhiteBalanceComp',
-        Writable => 'int16s',
-    },
-    0x2010 => {
-        Name => 'CMWhiteBalanceGrayPoint',
-        Writable => 'int16u',
-        Count => 3,
-    },
-    0x2020 => {
-        Name => 'CMSaturation',
-        Writable => 'int16s',
-        Count => 3,
-    },
-    0x2021 => {
-        Name => 'CMHue',
-        Writable => 'int16s',
-        Count => 3,
-    },
-    0x2022 => {
-        Name => 'CMContrast',
-        Writable => 'int16s',
-        Count => 3,
-    },
-    0x2023 => {
-        Name => 'CMSharpness',
-        Writable => 'int16s',
-        Count => 3,
-    },
+    0x2000 => { Name => 'CMExposureCompensation',   Writable => 'rational64s' },
+    0x2001 => { Name => 'CMWhiteBalance',           Writable => 'int16u' },
+    0x2002 => { Name => 'CMWhiteBalanceComp',       Writable => 'int16s' },
+    0x2010 => { Name => 'CMWhiteBalanceGrayPoint',  Writable => 'int16u', Count => 3 },
+    0x2020 => { Name => 'CMSaturation',             Writable => 'int16s', Count => 3 },
+    0x2021 => { Name => 'CMHue',                    Writable => 'int16s', Count => 3 },
+    0x2022 => { Name => 'CMContrast',               Writable => 'int16s', Count => 3 },
+    0x2023 => { Name => 'CMSharpness',              Writable => 'int16s', Count => 3 },
 );
 
@@ -3038,5 +3411,8 @@
     0x18 => {
         Name => 'Model',
+        Description => 'Camera Model Name',
         Format => 'string[8]',
+        SeparateTable => 'CameraType',
+        PrintConv => \%olympusCameraTypes,
     },
     # (01 00 at offset 0x20)
@@ -3045,5 +3421,5 @@
         Unknown => 1,
         Format => 'int32u',
-        # this conversion doesn't work for all models (ie. gives "1/100000")
+        # this conversion doesn't work for all models (eg. gives "1/100000")
         ValueConv => '$val ? 10 / $val : 0',
         PrintConv => 'Image::ExifTool::Exif::PrintExposureTime($val)',
@@ -3084,5 +3460,7 @@
     0x18 => {
         Name => 'Model',
+        Description => 'Camera Model Name',
         Format => 'string[24]',
+        Notes => 'the actual model name, no decoding necessary',
     },
     # (01 00 at offset 0x30)
@@ -3129,5 +3507,18 @@
     0x18 => {
         Name => 'Model',
+        Description => 'Camera Model Name',
         Format => 'string[24]',
+        Notes => 'oddly different than CameraType values in JPEG images by the same camera',
+        PrintConv => {
+            SG472 => 'u7040,S7040',
+            SG473 => 'u9010,S9010',
+            SG475 => 'SP800UZ',
+            SG551 => 'SZ-30MR',
+            SG553 => 'SP-610UZ',
+            SG554 => 'SZ-10',
+            SG555 => 'SZ-20',
+            SG573 => 'SZ-14',
+            SG575 => 'SP-620UZ',
+        },
     },
     0x28 => {
@@ -3141,8 +3532,236 @@
         PrintConv => 'Image::ExifTool::Exif::PrintFraction($val)',
     },
-    # NEED MORE SAMPLES TO DECODE THIS
+    # 0x38 - int32u: 3
+    # 0x3c - int32u: 1
+    # 0x40 - int16u: 5
+    # 0x42 - int16u: 0,4,9
+    # 0x64 - int32u: 0,6000,12000
+    # 0x48 - int32u: 100 (ISO?)
+    0x68 => {
+        Name => 'MovableInfo',
+        Condition => '$$valPt =~ /^DIGI/',
+        SubDirectory => { TagTable => 'Image::ExifTool::Olympus::MovableInfo' },
+    },
+    0x72 => {
+        Name => 'MovableInfo',
+        Condition => '$$valPt =~ /^DIGI/',
+        SubDirectory => { TagTable => 'Image::ExifTool::Olympus::MovableInfo' },
+    },
 );
 
+# yet a different QuickTime TAGS format (PH, E-M5)
+%Image::ExifTool::Olympus::MOV3 = (
+    GROUPS => { 0 => 'MakerNotes', 2 => 'Camera' },
+    NOTES => 'QuickTime information found in the TAGS atom of MOV videos from the E-M5.',
+    OLYM => {
+        Name => 'OlympusAtom',
+        SubDirectory => { TagTable => 'Image::ExifTool::Olympus::OLYM2' },
+    },
+);
+
+# yet a different QuickTime OLYM atom format (PH, E-M5)
+%Image::ExifTool::Olympus::OLYM2 = (
+    GROUPS => { 0 => 'MakerNotes', 2 => 'Camera' },
+    prms => {
+        Name => 'MakerNotes',
+        SubDirectory => { TagTable => 'Image::ExifTool::Olympus::prms' },
+    },
+    thmb =>{
+        Name => 'ThumbInfo',
+        SubDirectory => { TagTable => 'Image::ExifTool::Olympus::thmb2' },
+    },
+    scrn =>{
+        Name => 'PreviewInfo',
+        SubDirectory => { TagTable => 'Image::ExifTool::Olympus::scrn2' },
+    },
+);
+
+# the "prms" atom in E-M5 MOV videos (PH, E-M5)
+%Image::ExifTool::Olympus::prms = (
+    PROCESS_PROC => \&Image::ExifTool::ProcessBinaryData,
+    GROUPS => { 0 => 'MakerNotes', 2 => 'Camera' },
+    FIRST_ENTRY => 0,
+    NOTES => q{
+        Information extracted from the "prms" atom in MOV videos from Olympus models
+        such as the OM E-M5.
+    },
+    0x12 => {
+        Name => 'Make',
+        Format => 'string[24]',
+    },
+    0x2c => {
+        Name => 'Model',
+        Description => 'Camera Model Name',
+        Format => 'string[24]',
+        SeparateTable => 'CameraType',
+        PrintConv => \%olympusCameraTypes,
+    },
+    0x83 => {
+        Name => 'DateTime1',
+        Format => 'string[24]',
+        Groups => { 2 => 'Time' },
+    },
+    0x9d => {
+        Name => 'DateTime2',
+        Format => 'string[24]',
+        Groups => { 2 => 'Time' },
+    },
+);
+
+# yet a different "thmb" atom format (PH, E-M5)
+%Image::ExifTool::Olympus::thmb2 = (
+    PROCESS_PROC => \&Image::ExifTool::ProcessBinaryData,
+    GROUPS => { 0 => 'MakerNotes', 2 => 'Camera' },
+    0 => {
+        Name => 'ThumbnailWidth',
+        Format => 'int16u',
+    },
+    2 => {
+        Name => 'ThumbnailHeight',
+        Format => 'int16u',
+    },
+    4 => {
+        Name => 'ThumbnailLength',
+        Format => 'int32u',
+    },
+    8 => {
+        Name => 'ThumbnailImage',
+        Groups => { 2 => 'Preview' },
+        Format => 'undef[$val{4}]',
+        Notes => '160x120 JPEG thumbnail image',
+        RawConv => '$self->ValidateImage(\$val,$tag)',
+    },
+);
+
+# yet a different "scrn" atom format (PH, E-M5)
+%Image::ExifTool::Olympus::scrn2 = (
+    PROCESS_PROC => \&Image::ExifTool::ProcessBinaryData,
+    GROUPS => { 0 => 'MakerNotes', 2 => 'Camera' },
+    # 0 => int16u: 1 - number of preview images?
+    2 => {
+        Name => 'OlympusPreview',
+        SubDirectory => { TagTable => 'Image::ExifTool::Olympus::scrn' },
+    },
+);
+
+# movable information found in MP4 videos
+%Image::ExifTool::Olympus::MovableInfo = (
+    PROCESS_PROC => \&Image::ExifTool::ProcessBinaryData,
+    GROUPS => { 0 => 'MakerNotes', 2 => 'Camera' },
+    FIRST_ENTRY => 0,
+    0x04 => { #(NC)
+        Name => 'ISO',
+        Format => 'int32u',
+    },
+    0x2c => {
+        Name => 'EncoderVersion',
+        Format => 'string[16]',
+    },
+    0x3c => {
+        Name => 'DecoderVersion',
+        Format => 'string[16]',
+    },
+    0x83 => {
+        Name => 'Thumbnail',
+        SubDirectory => {
+            TagTable => 'Image::ExifTool::Olympus::Thumbnail',
+            Base => '$start', # (use a separate table because of this)
+        },
+    },
+);
+
+# thumbnail image information found in MP4 videos (similar in Olympus,Samsung,Sanyo) (ref PH)
+%Image::ExifTool::Olympus::Thumbnail = (
+    PROCESS_PROC => \&Image::ExifTool::ProcessBinaryData,
+    GROUPS => { 0 => 'MakerNotes', 2 => 'Camera' },
+    FIRST_ENTRY => 0,
+    FORMAT => 'int32u',
+    1 => 'ThumbnailWidth',
+    2 => 'ThumbnailHeight',
+    3 => 'ThumbnailLength',
+    4 => { Name => 'ThumbnailOffset', IsOffset => 1 },
+);
+
+# thumbnail information found in 'thmb' atom of MP4 videos from the TG-810 (ref PH)
+%Image::ExifTool::Olympus::thmb = (
+    NOTES => 'Information extracted from the "thmb" atom of Olympus MP4 videos.',
+    PROCESS_PROC => \&Image::ExifTool::ProcessBinaryData,
+    GROUPS => { 0 => 'MakerNotes', 2 => 'Camera' },
+    0 => {
+        Name => 'ThumbnailLength',
+        Format => 'int32u',
+    },
+    4 => {
+        Name => 'ThumbnailImage',
+        Groups => { 2 => 'Preview' },
+        Format => 'undef[$val{0}]',
+        Notes => '160x120 JPEG thumbnail image',
+        RawConv => '$self->ValidateImage(\$val,$tag)',
+    },
+);
+
+# thumbnail information found in 'scrn' atom of MP4 videos from the TG-810 (ref PH)
+%Image::ExifTool::Olympus::scrn = (
+    NOTES => 'Information extracted from the "scrn" atom of Olympus MP4 videos.',
+    PROCESS_PROC => \&Image::ExifTool::ProcessBinaryData,
+    GROUPS => { 0 => 'MakerNotes', 2 => 'Camera' },
+    0 => {
+        Name => 'PreviewImageLength',
+        Format => 'int32u',
+    },
+    4 => {
+        Name => 'PreviewImage',
+        Groups => { 2 => 'Preview' },
+        Format => 'undef[$val{0}]',
+        Notes => '640x480 JPEG preview image',
+        RawConv => '$self->ValidateImage(\$val,$tag)',
+    },
+);
+
+# information in OLYM atom of MP4 videos from the TG-810 (ref PH)
+%Image::ExifTool::Olympus::OLYM = (
+    NOTES => 'Tags found in the OLYM atom of MP4 videos from the TG-810.',
+    PROCESS_PROC => \&Image::ExifTool::ProcessBinaryData,
+    GROUPS => { 0 => 'MakerNotes', 2 => 'Camera' },
+    0x0e => {
+        Name => 'Make',
+        Format => 'string[26]',
+    },
+    0x28 => {
+        Name => 'Model',
+        Description => 'Camera Model Name',
+        Format => 'string[24]',
+        SeparateTable => 'CameraType',
+        PrintConv => \%olympusCameraTypes,
+    },
+    0x5a => {
+        Name => 'FNumber',
+        Format => 'rational64u',
+        PrintConv => 'sprintf("%.1f",$val)',
+    },
+    0x7f => {
+        Name => 'DateTimeOriginal', #(NC)
+        Description => 'Date/Time Original',
+        Format => 'string[24]',
+        Groups => { 2 => 'Time' },
+        PrintConv => '$self->ConvertDateTime($val)',
+    },
+    0x99 => {
+        Name => 'DateTime2',
+        Format => 'string[24]',
+        Groups => { 2 => 'Time' },
+    },
+    0x109 => {
+        Name => 'ThumbnailWidth',
+        Format => 'int16u',
+    },
+    0x10b => {
+        Name => 'ThumbnailHeight',
+        Format => 'int16u',
+    },
+);
+
 # tags in Olympus AVI videos (ref PH)
+# (very similar to Pentax::Junk2 tags)
 %Image::ExifTool::Olympus::AVI = (
     PROCESS_PROC => \&Image::ExifTool::ProcessBinaryData,
@@ -3155,6 +3774,9 @@
     },
     0x2c => {
-        Name => 'ModelType',
+        Name => 'Model',
+        Description => 'Camera Model Name',
         Format => 'string[24]',
+        SeparateTable => 'CameraType',
+        PrintConv => \%olympusCameraTypes,
     },
     0x5e => {
@@ -3173,13 +3795,7 @@
         Groups => { 2 => 'Time' },
     },
-    0x12d => {
-        Name => 'ThumbnailLength',
-        Format => 'int32u',
-    },
-    0x131 => {
-        Name => 'ThumbnailImage',
-        Format => 'undef[$val{0x12d}]',
-        Notes => '160x120 JPEG thumbnail image',
-        RawConv => '$self->ValidateImage(\$val,$tag)',
+    0x129 => {
+        Name => 'ThumbInfo',
+        SubDirectory => { TagTable => 'Image::ExifTool::Olympus::thmb2' },
     },
 );
@@ -3196,4 +3812,5 @@
     0x0c => {
         Name => 'Model',
+        Description => 'Camera Model Name',
         Format => 'string[16]',
     },
@@ -3257,4 +3874,44 @@
 );
 
+# DSS information written by Olympus voice recorders (ref PH)
+%Image::ExifTool::Olympus::DSS = (
+    PROCESS_PROC => \&Image::ExifTool::ProcessBinaryData,
+    GROUPS => { 0 => 'MakerNotes', 2 => 'Audio' },
+    FIRST_ENTRY => 0,
+    NOTES => q{
+        Information extracted from DSS/DS2 files and the ID3 XOLY frame of MP3 files
+        written by some Olympus voice recorders.
+    },
+    # 0 - file format:
+    #   "\x02dss"(DSS file and XOLY frame in MP3 file)
+    #   "\x03ds2"(DS2 file)
+    #   "\x03mp3"(ID3 XOLY frame in MP3 file)
+    12 => { Name => 'Model', Format => 'string[16]' }, # (name truncated by some models)
+    38 => {
+        Name => 'StartTime',
+        Format => 'string[12]',
+        Groups => { 2 => 'Time' },
+        ValueConv => '$val =~ s/(\d{2})(\d{2})(\d{2})(\d{2})(\d{2})(\d{2})/20$1:$2:$3 $4:$5:$6/; $val',
+        PrintConv => '$self->ConvertDateTime($val)',
+    },
+    50 => {
+        Name => 'EndTime',
+        Format => 'string[12]',
+        Groups => { 2 => 'Time' },
+        ValueConv => '$val =~ s/(\d{2})(\d{2})(\d{2})(\d{2})(\d{2})(\d{2})/20$1:$2:$3 $4:$5:$6/; $val',
+        PrintConv => '$self->ConvertDateTime($val)',
+    },
+    62 => {
+        Name => 'Duration',
+        Format => 'string[6]',
+        ValueConv => '$val =~ /(\d{2})(\d{2})(\d{2})/ ? ($1 * 60 + $2) * 60 + $3 : undef',
+        PrintConv => 'ConvertDuration($val)',
+    },
+    798 => { # (ref http://search.cpan.org/~rgibson/Audio-DSS-0.02/)
+        Name => 'Comment',
+        Format => 'string[100]',
+    },
+);
+
 # Olympus composite tags
 %Image::ExifTool::Olympus::Composite = (
@@ -3279,9 +3936,24 @@
     },
     ZoomedPreviewImage => {
+        Groups => { 2 => 'Preview' },
         Require => {
             0 => 'ZoomedPreviewStart',
             1 => 'ZoomedPreviewLength',
         },
-        RawConv => 'Image::ExifTool::Exif::ExtractImage($self,$val[0],$val[1],"ZoomedPreviewImage")',
+        RawConv => q{
+            @grps = $self->GetGroup($$val{0});  # set groups from input tag
+            Image::ExifTool::Exif::ExtractImage($self,$val[0],$val[1],"ZoomedPreviewImage");
+        },
+    },
+    # this is actually for PanasonicRaw tags, but it uses the lens lookup here
+    LensType => {
+        Require => {
+            0 => 'LensTypeMake',
+            1 => 'LensTypeModel',
+        },
+        Notes => 'based on tags found in some Panasonic RW2 images',
+        SeparateTable => 'LensType',
+        ValueConv => '"$val[0] $val[1]"',
+        PrintConv => \%olympusLensTypes,
     },
 );
@@ -3304,13 +3976,13 @@
     my @info = split ' ', $extender;
     # validate that extender identifier is reasonable
-    return 0 unless @info >= 2 and $info[1];
-    # if it's not an EC-14 (id 0 4) then assume it was really attached
+    return 0 unless @info >= 2 and hex($info[1]);
+    # if it's not an EC-14 (id '0 04') then assume it was really attached
     # (other extenders don't seem to affect the reported max aperture)
-    return 1 if "$info[0] $info[1]" ne '0 4';
+    return 1 if "$info[0] $info[1]" ne '0 04';
     # get the maximum aperture for this lens (in $1)
-    $lensType =~ / F(\d+(.\d+)?)/ or return 1;
+    $lensType =~ / F(\d+(\.\d+)?)/ or return 1;
     # If the maximum aperture at the maximum focal length is greater than the
     # known max/max aperture of the lens, then the extender must be attached
-    return ($maxAperture - $1 > 0.2) ? 1 : 2;
+    return(($maxAperture - $1 > 0.2) ? 1 : 2);
 }
 
@@ -3344,4 +4016,25 @@
 
 #------------------------------------------------------------------------------
+# Extract information from a DSS/DS2 voice recorder audio file or ID3 XOLY frame
+# Inputs: 0) ExifTool object reference, 1) dirInfo reference
+# Returns: 1 on success
+sub ProcessDSS($$;$)
+{
+    my ($et, $dirInfo) = @_;
+
+    # allow this to be called with either RAF or DataPt
+    my $raf = $$dirInfo{RAF};
+    if ($raf) {
+        my $buff;
+        $raf->Read($buff, 898) > 68 or return 0;
+        $buff =~ /^(\x02dss|\x03ds2)/ or return 0;
+        $dirInfo = { DataPt => \$buff };
+        $et->SetFileType(uc substr $buff, 1, 3);
+    }
+    my $tagTablePtr = GetTagTable('Image::ExifTool::Olympus::DSS');
+    return $et->ProcessBinaryData($dirInfo, $tagTablePtr);
+}
+
+#------------------------------------------------------------------------------
 # Process ORF file
 # Inputs: 0) ExifTool object reference, 1) directory information reference
@@ -3349,6 +4042,6 @@
 sub ProcessORF($$)
 {
-    my ($exifTool, $dirInfo) = @_;
-    return $exifTool->ProcessTIFF($dirInfo);
+    my ($et, $dirInfo) = @_;
+    return $et->ProcessTIFF($dirInfo);
 }
 
@@ -3372,5 +4065,5 @@
 =head1 AUTHOR
 
-Copyright 2003-2011, Phil Harvey (phil at owl.phy.queensu.ca)
+Copyright 2003-2021, Phil Harvey (philharvey66 at gmail.com)
 
 This library is free software; you can redistribute it and/or modify it
Index: /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/OpenEXR.pm
===================================================================
--- /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/OpenEXR.pm	(revision 34921)
+++ /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/OpenEXR.pm	(revision 34921)
@@ -0,0 +1,324 @@
+#------------------------------------------------------------------------------
+# File:         OpenEXR.pm
+#
+# Description:  Read OpenEXR meta information
+#
+# Revisions:    2011/12/10 - P. Harvey Created
+#
+# References:   1) http://www.openexr.com/
+#------------------------------------------------------------------------------
+
+package Image::ExifTool::OpenEXR;
+
+use strict;
+use vars qw($VERSION);
+use Image::ExifTool qw(:DataAccess :Utils);
+use Image::ExifTool::GPS;
+
+$VERSION = '1.02';
+
+# supported EXR value format types (other types are extracted as undef binary data)
+my %formatType = (
+    box2f          => 'float[4]',
+    box2i          => 'int32s[4]',
+    chlist         => 1,
+    chromaticities => 'float[8]',
+    compression    => 'int8u',
+    double         => 'double',
+    envmap         => 'int8u',
+    float          => 'float',
+   'int'           => 'int32s',
+    keycode        => 'int32s[7]',
+    lineOrder      => 'int8u',
+    m33f           => 'float[9]',
+    m44f           => 'float[16]',
+    rational       => 'rational64s',
+    string         => 'string', # incorrect in specification! (no leading int)
+    stringvector   => 1,
+    tiledesc       => 1,
+    timecode       => 'int32u[2]',
+    v2f            => 'float[2]',
+    v2i            => 'int32s[2]',
+    v3f            => 'float[3]',
+    v3i            => 'int32s[3]',
+);
+
+# OpenEXR tags
+%Image::ExifTool::OpenEXR::Main = (
+    GROUPS => { 2 => 'Image' },
+    NOTES => q{
+        Information extracted from EXR images.  See L<http://www.openexr.com/> for
+        the official specification.
+    },
+    _ver => { Name => 'EXRVersion' },
+    _lay => {
+        Name => 'Layout',
+        PrintHex => 1,
+        PrintConv => { 0 => 'Scan Lines', 0x200 => 'Tiles' },
+    },
+    adoptedNeutral      => { },
+    altitude => {
+        Name => 'GPSAltitude',
+        Groups => { 2 => 'Location' },
+        PrintConv => q{
+            $val = int($val * 10) / 10;
+            return(($val =~ s/^-// ? "$val m Below" : "$val m Above") . " Sea Level");
+        },
+    },
+    aperture            => { PrintConv => 'sprintf("%.1f",$val)' },
+    channels            => { },
+    chromaticities      => { },
+    capDate => {
+        Name => 'DateTimeOriginal',
+        Description => 'Date/Time Original',
+        Groups => { 2 => 'Time' },
+        PrintConv => '$self->ConvertDateTime($val)',
+    },
+    comments            => { },
+    compression => {
+        PrintConvColumns => 2,
+        PrintConv => {
+            0 => 'None',
+            1 => 'RLE',
+            2 => 'ZIPS',
+            3 => 'ZIP',
+            4 => 'PIZ',
+            5 => 'PXR24',
+            6 => 'B44',
+            7 => 'B44A',
+        },
+    },
+    dataWindow          => { },
+    displayWindow       => { },
+    envmap => {
+        Name => 'EnvironmentMap',
+        PrintConv => {
+            0 => 'Latitude/Longitude',
+            1 => 'Cube',
+        },
+    },
+    expTime => {
+        Name => 'ExposureTime',
+        PrintConv => 'Image::ExifTool::Exif::PrintExposureTime($val)',
+    },
+    focus => {
+        Name => 'FocusDistance',
+        PrintConv => '"$val m"',
+    },
+    framesPerSecond     => { },
+    keyCode             => { },
+    isoSpeed            => { Name => 'ISO' },
+    latitude => {
+        Name => 'GPSLatitude',
+        Groups => { 2 => 'Location' },
+        PrintConv => 'Image::ExifTool::GPS::ToDMS($self, $val, 1, "N")',
+    },
+    lineOrder => {
+        PrintConv => {
+            0 => 'Increasing Y',
+            1 => 'Decreasing Y',
+            2 => 'Random Y',
+        },
+    },
+    longitude => {
+        Name => 'GPSLongitude',
+        Groups => { 2 => 'Location' },
+        PrintConv => 'Image::ExifTool::GPS::ToDMS($self, $val, 1, "E")',
+    },
+    lookModTransform    => { },
+    multiView           => { },
+    owner               => { Groups => { 2 => 'Author' } },
+    pixelAspectRatio    => { },
+    preview             => { },
+    renderingTransform  => { },
+    screenWindowCenter  => { },
+    screenWindowWidth   => { },
+    tiles               => { },
+    timeCode            => { },
+    utcOffset => {
+        Name => 'TimeZone',
+        Groups => { 2 => 'Time' },
+        PrintConv => 'TimeZoneString($val / 60)',
+    },
+    whiteLuminance      => { },
+    worldToCamera       => { },
+    worldToNDC          => { },
+    wrapmodes           => { Name => 'WrapModes' },
+    xDensity            => { Name => 'XResolution' },
+    # also observed:
+    # ilut
+);
+
+#------------------------------------------------------------------------------
+# Extract information from an OpenEXR file
+# Inputs: 0) ExifTool object reference, 1) DirInfo reference
+# Returns: 1 on success, 0 if this wasn't a valid OpenEXR file
+sub ProcessEXR($$)
+{
+    my ($et, $dirInfo) = @_;
+    my $raf = $$dirInfo{RAF};
+    my $verbose = $et->Options('Verbose');
+    my $binary = $et->Options('Binary') || $verbose;
+    my ($buff, $dim);
+
+    # verify this is a valid RIFF file
+    return 0 unless $raf->Read($buff, 8) == 8;
+    return 0 unless $buff =~ /^\x76\x2f\x31\x01/s;
+    $et->SetFileType();
+    SetByteOrder('II');
+    my $tagTablePtr = GetTagTable('Image::ExifTool::OpenEXR::Main');
+
+    # extract information from header
+    my $ver = unpack('x4V', $buff);
+    $et->HandleTag($tagTablePtr, '_ver', $ver & 0xff);
+    $et->HandleTag($tagTablePtr, '_lay', $ver & 0x200);
+
+    # extract attributes
+    for (;;) {
+        $raf->Read($buff, 68) or last;
+        last if $buff =~ /^\0/;
+        unless ($buff =~ /^([^\0]{1,31})\0([^\0]{1,31})\0(.{4})/sg) {
+            $et->Warn('EXR format error');
+            last;
+        }
+        my ($tag, $type, $size) = ($1, $2, unpack('V', $3));
+        unless ($raf->Seek(pos($buff) - length($buff), 1)) {
+            $et->Warn('Seek error');
+            last;
+        }
+        my $tagInfo = $et->GetTagInfo($tagTablePtr, $tag);
+        unless ($tagInfo) {
+            my $name = ucfirst $tag;
+            $name =~ tr/-_a-zA-Z0-9//dc;
+            if (length $name <= 1) {
+                if (length $name) {
+                    $name = "Tag$name";
+                } else {
+                    $name = 'Invalid';
+                }
+            }
+            $tagInfo = { Name => $name };
+            AddTagToTable($tagTablePtr, $tag, $tagInfo);
+            $et->VPrint(0, $$et{INDENT}, "[adding $tag]\n");
+        }
+        my ($val, $success);
+        my $format = $formatType{$type};
+        if ($format or $binary) {
+            $raf->Read($buff, $size) == $size and $success = 1;
+            if (not $format) {
+                $val = \$buff;  # treat as undef binary data
+            } elsif ($format ne '1') {
+                # handle formats which map nicely into ExifTool format codes
+                if ($format =~ /^(\w+)\[?(\d*)/) {
+                    my ($fmt, $cnt) = ($1, $2);
+                    $cnt = $fmt eq 'string' ? $size : 1 unless $cnt;
+                    $val = ReadValue(\$buff, 0, $fmt, $cnt, $size);
+                }
+            # handle other format types
+            } elsif ($type eq 'tiledesc') {
+                if ($size >= 9) {
+                    my $x = Get32u(\$buff, 0);
+                    my $y = Get32u(\$buff, 4);
+                    my $mode = Get8u(\$buff, 8);
+                    my $lvl = { 0 => 'One Level', 1 => 'MIMAP Levels', 2 => 'RIPMAP Levels' }->{$mode & 0x0f};
+                    $lvl or $lvl = 'Unknown Levels (' . ($mode & 0xf) . ')';
+                    my $rnd = { 0 => 'Round Down', 1 => 'Round Up' }->{$mode >> 4};
+                    $rnd or $rnd = 'Unknown Rounding (' . ($mode >> 4) . ')';
+                    $val = "${x}x$y; $lvl; $rnd";
+                }
+            } elsif ($type eq 'chlist') {
+                $val = [ ];
+                while ($buff =~ /\G([^\0]{1,31})\0(.{16})/sg) {
+                    my ($str, $dat) = ($1, $2);
+                    my ($pix,$lin,$x,$y) = unpack('VCx3VV', $dat);
+                    $pix = { 0 => 'int8u', 1 => 'half', 2 => 'float' }->{$pix} || "unknown($pix)";
+                    push @$val, "$str $pix" . ($lin ? ' linear' : '') . " $x $y";
+                }
+            } elsif ($type eq 'stringvector') {
+                $val = [ ];
+                my $pos = 0;
+                while ($pos + 4 <= length($buff)) {
+                    my $len = Get32u(\$buff, $pos);
+                    last if $pos + 4 + $len > length($buff);
+                    push @$val, substr($buff, $pos + 4, $len);
+                    $pos += 4 + $len;
+                }
+            } else {
+                $val = \$buff;  # (shouldn't happen)
+            }
+        } else {
+            # avoid loading binary data
+            $val = \ "Binary data $size bytes";
+            $success = $raf->Seek($size, 1);
+        }
+        unless ($success) {
+            $et->Warn('Truncated or corrupted EXR file');
+            last;
+        }
+        $val = '<bad>' unless defined $val;
+
+        # take image dimensions from dataWindow (with displayWindow as backup)
+        if (($tag eq 'dataWindow' or (not $dim and $tag eq 'displayWindow')) and
+            $val =~ /^(-?\d+) (-?\d+) (-?\d+) (-?\d+)$/)
+        {
+            $dim = [$3 - $1 + 1, $4 - $2 + 1];
+        }
+        if ($verbose) {
+            my $dataPt = ref $val ? $val : \$val,
+            $et->VerboseInfo($tag, $tagInfo,
+                Table   => $tagTablePtr,
+                Value   => $val,
+                Size    => $size,
+                Format  => $type,
+                DataPt  => \$buff,
+                Addr    => $raf->Tell() - $size,
+            );
+        }
+        $et->FoundTag($tagInfo, $val);
+    }
+    if ($dim) {
+        $et->FoundTag('ImageWidth', $$dim[0]);
+        $et->FoundTag('ImageHeight', $$dim[1]);
+    }
+    return 1;
+}
+
+1;  # end
+
+__END__
+
+=head1 NAME
+
+Image::ExifTool::OpenEXR - Read OpenEXR meta information
+
+=head1 SYNOPSIS
+
+This module is used by Image::ExifTool
+
+=head1 DESCRIPTION
+
+This module contains definitions required by Image::ExifTool to extract meta
+information from OpenEXR images.
+
+=head1 AUTHOR
+
+Copyright 2003-2021, Phil Harvey (philharvey66 at gmail.com)
+
+This library is free software; you can redistribute it and/or modify it
+under the same terms as Perl itself.
+
+=head1 REFERENCES
+
+=over 4
+
+=item L<http://www.openexr.com/documentation.html>
+
+=back
+
+=head1 SEE ALSO
+
+L<Image::ExifTool::TagNames/OpenEXR Tags>,
+L<Image::ExifTool(3pm)|Image::ExifTool>
+
+=cut
+
